//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * Lampサウンド実装
 * @author Junpee
 */

#include "LampBasic.h"
#include "Sound/System/LampSound.h"
#include "Sound/System/SoundDefinition.h"
#include "Sound/System/SoundCapacity.h"
#include "Sound/System/SoundManager.h"
#include "Sound/3D/SoundListener.h"

namespace Lamp{

// DirectSound
DirectSound* LampSound::directSound_ = NULL;
// プライマリバッファ
DirectSoundPrimaryBuffer* LampSound::primaryBuffer_ = NULL;
// サウンド能力
SoundCapacity* LampSound::soundCapacity_ = NULL;
// サウンドマネージャ
SoundManager* LampSound::soundManager_ = NULL;
// サウンドリスナ
SoundListener* LampSound::soundListener_;
// サンプル数
int LampSound::sample_ = 0;
// チャンネル数
int LampSound::channel_ = 0;
// ビット数
int LampSound::bit_ = 0;
// 初期化フラグ
bool LampSound::isInitialized_ = false;

//------------------------------------------------------------------------------
// 初期化
bool LampSound::initialize(HWND windowHandle){
	if(isInitialized_){ return true; }
	LampCore::initialize();
	// DirectSound作成
	if(DirectXFailed(DirectSoundCreate8(
		&DSDEVID_DefaultPlayback, &directSound_, NULL))){
		ErrorOut("LampSound::initialize() DirectSoundの作成に失敗しました");
		return false;
	}
	// 協調レベルの設定
	if(DirectXFailed(directSound_->SetCooperativeLevel(
		windowHandle, DSSCL_PRIORITY))){
		ErrorOut("LampSound::initialize() 協調レベルの設定に失敗しました");
		return false;
	}
	// サウンドメモリの再配置
	if(DirectXFailed(directSound_->Compact())){
		ErrorOut("LampSound::initialize() サウンドメモリの再配置に失敗しました");
		return false;
	}
	// サウンド能力の取得
	soundCapacity_ = new SoundCapacity();
	if(!soundCapacity_->initialize(directSound_)){
		ErrorOut("LampSound::initialize() サウンド能力の取得に失敗しました");
		return false;
	}
	// プライマリバッファの作成
	DSBUFFERDESC bufferDescription;
	::memset(&bufferDescription, 0, sizeof(DSBUFFERDESC));
	bufferDescription.dwSize = sizeof(DSBUFFERDESC);
	// プライマリバッファ、3Dリスナ
	bufferDescription.dwFlags = (DSBCAPS_PRIMARYBUFFER | DSBCAPS_CTRL3D);
	if(DirectXFailed(directSound_->CreateSoundBuffer(
		&bufferDescription, &primaryBuffer_, NULL))){
		ErrorOut("LampSound::initialize() "
			"プライマリバッファの作成に失敗しました");
		return false;
	}
	// プライマリバッファのフォーマット指定
	WAVEFORMATEX waveFormat;
	::memset(&waveFormat, 0, sizeof(WAVEFORMATEX));
	waveFormat.wFormatTag = WAVE_FORMAT_PCM;
	if(SoundDefinition::primaryBufferStereo){
		waveFormat.nChannels = 2;
	}else{
		waveFormat.nChannels = 1;
	}
	waveFormat.nSamplesPerSec = SoundDefinition::primaryBufferRate;
	waveFormat.wBitsPerSample = SoundDefinition::primaryBufferBit;
	waveFormat.nBlockAlign =
		(waveFormat.nChannels * waveFormat.wBitsPerSample) / 8;
	waveFormat.nAvgBytesPerSec =
		waveFormat.nSamplesPerSec * waveFormat.nBlockAlign;
	if(DirectXFailed(primaryBuffer_->SetFormat(&waveFormat))){
		ErrorOut("LampSound::initialize() "
			"プライマリバッファのフォーマット設定に失敗しました");
		return false;
	}
	// フォーマットの取得
	::memset(&waveFormat, 0, sizeof(WAVEFORMATEX));
	if(DirectXFailed(primaryBuffer_->GetFormat(
		&waveFormat, sizeof(WAVEFORMATEX), NULL))){
		ErrorOut("LampSound::initialize() "
			"プライマリバッファのフォーマット取得に失敗しました");
		return false;
	}
	sample_ = waveFormat.nSamplesPerSec;
	channel_ = waveFormat.nChannels;
	bit_ = waveFormat.wBitsPerSample;
	// サウンドマネージャ初期化
	soundManager_ = new SoundManager(directSound_);
	// サウンドリスナの初期化
	soundListener_ = new SoundListener(primaryBuffer_);
	// 初期化フラグ立てる
	isInitialized_ = true;
	return true;
}
//------------------------------------------------------------------------------
// 後始末
void LampSound::finalize(){
	// サウンドリスナ解放
	SafeDelete(soundListener_);
	// サウンドマネージャ解放
	SafeDelete(soundManager_);
	// サウンド能力解放
	SafeDelete(soundCapacity_);
	// プライマリバッファ解放
	SafeRelease(primaryBuffer_);
	// DirectSound解放
	SafeRelease(directSound_);
	// 初期化フラグクリア
	isInitialized_ = false;
}
//------------------------------------------------------------------------------
// プレゼンテーション
void LampSound::presentation(){
	if(!isInitialized_){ return; }
	// サウンドの更新
	soundManager_->update();
	// 3D設定を適用する
	soundListener_->apply3DSettings();
}
//------------------------------------------------------------------------------
// 文字列への変換
String LampSound::toString(){
	Assert(isInitialized_);
	String result;
	result.format("PrimarySoundBuffer  %dHz %dChannel %dBit",
		getSample(), getChannel(), getBit());
	return result;
}
//------------------------------------------------------------------------------
} // End of namespace Lamp
//------------------------------------------------------------------------------
